unit Global;

interface

uses SysUtils;

  function CheckSum(Code: string): Char;
  function ShowCode(Code: string): AnsiString;

const
  LucentEndCode = Chr($20) + Chr($04);
  STX = #2;
  ETX = #3;

var
  WallboardLength: integer; // r@bΦr
  ColorLed: Boolean; // rαm(0 ; 1 m)

implementation

function CheckSum(Code: string): Char;
var i: Integer;
  cks: Byte;
begin
  cks := $00;
  for i := 1 to Length(Code) do
    cks := cks xor Byte(Code[i]);
  Result := Char(cks);
end;

function ShowCode(Code: string): AnsiString;
var sCatch: String;
  i: Integer;
begin
  Result := '';
  for i:= 1 to Length(Code) do begin
    sCatch := Format('%X', [Ord(Code[i])] );
    if Length(sCatch)=1 then
      sCatch := '0' + sCatch;
    Result := Result + sCatch + ' ' ;
  end;
end;

end.
