unit UT_Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ADODb, ComCtrls, StdCtrls, ExtCtrls, Buttons, Mask, Spin, Grids,
  Wwdbigrd, Wwdbgrid, wwSpeedButton, wwDBNavigator, wwdbedit,
  Wwdotdot, Wwdbcomb, Wwdbspin, wwclearpanel,
  OoMisc, AdPort, AdWnPort, AppEvnts;

type
  TfrmMain = class(TForm)
    pgMain: TPageControl;
    tabViewMsg: TTabSheet;
    tabWallBorad: TTabSheet;
    tabItem: TTabSheet;
    tabOther: TTabSheet;
    Memo: TMemo;
    navWallBoard: TwwDBNavigator;
    dbgWallBoard: TwwDBGrid;
    dbgDispSeq_1: TwwDBGrid;
    navWallBoardInsert: TwwNavButton;
    navWallBoardDelete: TwwNavButton;
    navWallBoardEdit: TwwNavButton;
    navWallBoardPost: TwwNavButton;
    navWallBoardCancel: TwwNavButton;
    pnlDispseq1: TPanel;
    pnlDispColor: TPanel;
    navDispSeq: TwwDBNavigator;
    dbgDispSeq_2: TwwDBGrid;
    navDispColor: TwwDBNavigator;
    navDispColorInsert: TwwNavButton;
    navDispColorDelete: TwwNavButton;
    navDispColorEdit: TwwNavButton;
    navDispColorPost: TwwNavButton;
    navDispColorCancel: TwwNavButton;
    dbgDispColor: TwwDBGrid;
    navDispSeqInsert: TwwNavButton;
    navDispSeqDelete: TwwNavButton;
    navDispSeqEdit: TwwNavButton;
    navDispSeqPost: TwwNavButton;
    navDispSeqCancel: TwwNavButton;
    spValue: TwwDBSpinEdit;
    spSize: TwwDBSpinEdit;
    cmbColor: TwwDBComboBox;
    cmbLocation: TwwDBComboBox;
    cmbIDNO: TwwDBComboBox;
    tabValueView: TTabSheet;
    GroupBox4: TGroupBox;
    dbgItemStatus: TwwDBGrid;
    pnlGroupItem: TPanel;
    GroupBox3: TGroupBox;
    navSrvGroup: TwwDBNavigator;
    navSrvGroupInsert: TwwNavButton;
    navSrvGroupDelete: TwwNavButton;
    navSrvGroupEdit: TwwNavButton;
    navSrvGroupPost: TwwNavButton;
    navSrvGroupCancel: TwwNavButton;
    dbgService_Grp: TwwDBGrid;
    GroupBox2: TGroupBox;
    dbgItemType: TwwDBGrid;
    navItem: TwwDBNavigator;
    navItemInsert: TwwNavButton;
    navItemEdit: TwwNavButton;
    navItemPost: TwwNavButton;
    navItemCancel: TwwNavButton;
    pnlMsgButton: TPanel;
    btnClearMemo: TBitBtn;
    ckbACDShowCode: TCheckBox;
    spGrp_Size: TwwDBSpinEdit;
    cmbItem: TwwDBComboBox;
    cmbItemName: TwwDBComboBox;
    cmbGrpVDNName: TwwDBComboBox;
    Splitter1: TSplitter;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    pnlWallboardLocation: TPanel;
    gbWallboardLocation: TGroupBox;
    dbgWallboardLocation: TwwDBGrid;
    navWallboardLocation: TwwDBNavigator;
    navWallboardLocationInsert: TwwNavButton;
    navWallboardLocationDelete: TwwNavButton;
    navWallboardLocationEdit: TwwNavButton;
    navWallboardLocationPost: TwwNavButton;
    navWallboardLocationCancel: TwwNavButton;
    ApdWinsockPort1: TApdWinsockPort;
    tmSend: TTimer;
    btnMakeCommonCode: TButton;
    btnMakeLucentCode: TButton;
    btnSend: TButton;
    btnTimerState: TButton;
    lblSendInterval: TLabel;
    seSendInterval: TSpinEdit;
    Splitter5: TSplitter;
    GroupBox1: TGroupBox;
    wwDBNavigator1: TwwDBNavigator;
    wwNavButton1: TwwNavButton;
    wwNavButton2: TwwNavButton;
    wwNavButton3: TwwNavButton;
    wwNavButton4: TwwNavButton;
    wwNavButton5: TwwNavButton;
    wwDBGrid1: TwwDBGrid;
    cmbGrpVDNColor: TwwDBComboBox;
    ApplicationEvents1: TApplicationEvents;
    dbseDelay: TwwDBSpinEdit;
    ckbMsgShowCode: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnSendClick(Sender: TObject);
    procedure btnClearMemoClick(Sender: TObject);
    procedure ApdWinsockPortWsConnect(Sender: TObject);
    procedure ApdWinsockPortWsDisconnect(Sender: TObject);
    procedure ApdWinsockPortWsError(Sender: TObject; ErrCode: Integer);
    procedure btnMakeLucentCodeClick(Sender: TObject);
    procedure btnMakeCommonCodeClick(Sender: TObject);
    procedure tmSendTimer(Sender: TObject);
    procedure btnTimerStateClick(Sender: TObject);
    procedure seSendIntervalChange(Sender: TObject);
    procedure ApplicationEvents1Exception(Sender: TObject; E: Exception);
  private
    PrevTimer: Boolean;
  public
    procedure LinkSQL;
    procedure ReadSysParam;
    procedure SetComboItem;
  end;

type
  TLed = record
    IP: string; // Wallboard  IP
    tcp1: TApdWinsockPort; // tcp1 e Call Center T;
    StopBeepTimer: TTimer;
    // Lucent ƭȳ
    IDNOArray: array[0..19] of Integer;
    IDNOCount: Integer;
    // ^T
    // ShowInlet  True, T; ShowInlet  False,  ShowFixCyc  True, h Fixtime P Cycle T
    // ShowInlet P ShowFixCyc Ҭ False, hǰe Lucent ƭ
    ShowInlet, ShowFixCyc: Boolean;
    // TǰeX, @(@Ӧ渹)s@
    InletCode: array of AnsiString;
    // OWTǰeX; P InletCode , ̤P, ~ǰe InletCode
    InletCode_Old: array of AnsiString;
    // w/gTǰeX, @s@
    FixCycCode: array of AnsiString;
    // OWw/gTǰeX; P FixCycCode , ̤P, ~ǰe FixCycCode
    FixCycCode_Old: array of AnsiString;

    //NowMsgKind: Integer; // 0: Ĥ@ǰe; 1: ^T; 2: Lucent ƭ
    HadClear: Boolean;
  end;

var
  frmMain: TfrmMain;
  // -- WallCtrl 
  aLed: array of TLed;
  nWallBoardCount: Integer;
  // C IDNO ǰeX(t STX//A1H/渹  CheckSum/ETX)
//  UpCodeByIDNO: array of AnsiString; // W
//  DnCodeByIDNO: array of AnsiString; // U
  CodeByIDNO: array of AnsiString;
  LineFE: AnsiString;

implementation

uses UT_dmTable, Global, ShellApi;

{$R *.DFM}

procedure TfrmMain.LinkSQL;
begin
  try
    dmTable.connMain.Connected := True;
    dmTable.tblDispColor.Active := True;
    dmTable.tblDispSeq.Active := True;
    dmTable.tblItemType.Active := True;
    dmTable.tblSrvGroup.Active := True;
    dmTable.tblWallBoard.Active := True;
    dmTable.tblWallboardLocation.Active := True;
    dmTable.tblMakeCodeByIDNO.Active := True;
    dmTable.tblVDN.Active := True;
  except
  end;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
var i: Integer;
begin
  PrevTimer := False;
  LinkSQL; // sƮw(WallCtrl.mdb)
  ReadSysParam; // ŪtΩһݪѼ( WallCtrl.mdb  SysParam Table)

  if not ColorLed then begin
    dmTable.tblDispseq.FieldByName('GrpVDNColor').Visible := False;
    dmTable.tblDispColor.FieldByName('HColor').Visible := False;
    dmTable.tblDispColor.FieldByName('BColor').Visible := False;
    dmTable.tblDispColor.FieldByName('LColor').Visible := False;
  end;

  Memo.Clear;
  SetComboItem; // JU ComboBox  Items

  if ColorLed then
    LineFE := 'A2'#177#254#1'N'#192
  else
    LineFE := 'A2'#161#254#1'N'#208;
  if ColorLed then
    for i := 1 to WallboardLength*2 do
       LineFE := LineFE + #1 + ' '
  else
    for i := 1 to WallboardLength*2 do
       LineFE := LineFE + ' ';
  LineFE := LineFE + 'N';
  LineFE := LineFE + CheckSum(LineFE);
  LineFE := STX + LineFE + ETX;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
var i, j: Integer;
  tbl: TADOTable;
begin
  pgMain.ActivePage := tabViewMsg;

  tbl := dmTable.tblWallboard;
  nWallBoardCount := tbl.RecordCount;
  SetLength(aLed, nWallboardCount);
  for i := 0 to nWallBoardCount - 1 do begin
    // l Winsock(TApdWinsockPort )
    aLed[i].IP := tbl.FieldByName('IP').AsString;
    aLed[i].tcp1 := TApdWinsockPort.Create(Self);
    aLed[i].tcp1.DeviceLayer := dlWinsock;
    aLed[i].tcp1.WsAddress := aLed[i].IP;
    aLed[i].tcp1.WsPort := '4660';
    aLed[i].tcp1.OutSize := 8192;
    aLed[i].tcp1.OnWsConnect := ApdWinsockPortWsConnect;
    aLed[i].tcp1.OnWsDisconnect := ApdWinsockPortWsDisconnect;
    aLed[i].tcp1.OnWsError := ApdWinsockPortWsError;
    aLed[i].tcp1.Open := True;

    // Lucent ƭȳ
    for j := 0 to High(aLed[i].IDNOArray) do
      aLed[i].IDNOArray[j] := tbl.FieldByName('IDNO' + IntToStr(j+1)).AsInteger;
    aLed[i].IDNOCount := 0; // ӤݪOܪ

    // ^T
    aLed[i].ShowInlet := False;
    aLed[i].ShowFixCyc := False;

    aLed[i].HadClear := False;

    tbl.Next;
  end;
  tbl.First;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
var i: Integer;
begin
  for i := 0 to High(aLed) do
    aLed[i].tcp1.Open := False;
end;

procedure TfrmMain.ReadSysParam;
var tbl: TADOTable;
begin
  tbl := TADOTable.Create(nil);
  try
    tbl.Connection := dmTable.connMain;
    tbl.TableName := 'SysParam';
    tbl.Open;
    if tbl.IsEmpty then begin
      MessageDlg('tγ]w(SysParam)L', mtError, [mbOk], 0);
      dmTable.connMain.Close;
    end else begin
      WallboardLength := tbl.FieldByName('WallboardLength').AsInteger; // rCbΦr
      ColorLed := tbl.FieldByName('ColorLed').AsInteger <> 0; // 0 r; _hmr
    end;
  finally
    tbl.Free;
  end;
end;

procedure TfrmMain.btnSendClick(Sender: TObject);
  procedure DelayMSec(MSec: DWord);
  var iEndTick: DWord;
  begin
    iEndTick := GetTickCount + MSec;
    while GetTickCount <= iEndTick do begin
      Application.ProcessMessages;
      Sleep(300);
    end;
  end;

  function GetLineCountCode(const StationNo: string;
    const LineCount: Integer): AnsiString;
  begin
    // ܦ渹 => rǰe(A8H) / (mre B8H)
    // 02H +  + ܦ渹 + _l渹 + 渹 + CheckSum + 03H
    if ColorLed then
      Result := StationNo + #184#1 + Chr(LineCount) // A8H
    else
      Result := StationNo + #168#1 + Chr(LineCount); // B8H
    Result := STX + Result + CheckSum(Result) + ETX;
  end;
  procedure SendCode(const tcp: TApdWinsockPort; ACode: Ansistring;
    AWaitAck: Boolean);
  begin
    tcp.PutString(ACode);
    Application.ProcessMessages;
    if not AWaitAck then
      DelayMSec(240)
    else
      case tcp.WaitForMultiString(#6'^'#21, 90, True, True, '^') of
        0: Memo.Lines.Add('Ack Timeout');
        1: Memo.Lines.Add('Ack');
        2: if (Byte(ACode[4]) in [$A1, $B1]) then
             Memo.Lines.Add(IntToStr(Byte(ACode[5])) + ' 渹 Nak')
           else if (Byte(ACode[4]) in [$A8, $B8]) then
             Memo.Lines.Add('ܦ渹 Nak');
      end;
  end;
var i, j, k, TmpIDNOCount, TmpLineNo: Integer;
  TmpCode: AnsiString;
  qry: TADOQuery;
  IsDifferent: Boolean;
begin
  for i := 0 to nWallBoardCount - 1 do begin // ݪOǰe
    Memo.Lines.add('');
    Memo.Lines.Add('========= ' + aLed[i].tcp1.WsAddress + ' =========');
    if not aLed[i].tcp1.Open then begin
      aLed[i].tcp1.Open := False;
      Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + '<<ss>> '+ aLed[i].IP);
      aLed[i].tcp1.Open := True;
    end;
    if not aLed[i].tcp1.Open then Continue; // ݪOs, ǰe

    if aLed[i].ShowInlet then begin // 
      Memo.Lines.add('ǰeT');
      aLed[i].HadClear := False;
      // Ĥ@ǰeT
      if (High(aLed[i].InletCode_Old) = -1) then begin
        if ColorLed then begin // m
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
          SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True); // ܦ渹 FEH ~ FEH
        end else begin // 
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
          SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
        end;

        for j := 0 to High(aLed[i].InletCode) do begin // AǰeTX(A1H)
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(aLed[i].InletCode[j]));
          for k := 1 to 2 do
            SendCode(aLed[i].tcp1, aLed[i].InletCode[j], True);
        end;
        // ǰeݪOnܭXӹ(_lP)X
        if ckbMsgShowCode.Checked then
          Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].InletCode) + 1)));
        for k := 1 to 2 do
          SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].InletCode) + 1), True);
      end else if (High(aLed[i].InletCode) <> High(aLed[i].InletCode_Old)) then begin
        // sTƤªh
        if High(aLed[i].InletCode) > High(aLed[i].InletCode_Old) then begin
          IsDifferent := False;
          for j := 0 to High(aLed[i].InletCode_Old) do
            if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then begin
              IsDifferent := True;
              Break;
            end;
          if IsDifferent then begin
            if ColorLed then begin // m
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
              SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True); // ܦ渹 FEH ~ FEH
            end else begin // 
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
              SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
            end;
            for j := 0 to High(aLed[i].InletCode_Old) do
              if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then begin
                if ckbMsgShowCode.Checked then
                  Memo.Lines.Add(ShowCode(aLed[i].InletCode[j]));
                for k := 1 to 2 do
                  SendCode(aLed[i].tcp1, aLed[i].InletCode[j], True);
              end;
            for j := High(aLed[i].InletCode_Old) + 1 to High(aLed[i].InletCode) do begin
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(aLed[i].InletCode[j]));
              for k := 1 to 2 do
                SendCode(aLed[i].tcp1, aLed[i].InletCode[j], True);
            end;
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(showCode(GetLineCountCode('A2', High(aLed[i].InletCode) + 1)));
            for k := 1 to 2 do
              SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].InletCode) + 1), True);
          end;
        end;
        // sTƤª
        if High(aLed[i].InletCode) < High(aLed[i].InletCode_Old) then begin
          IsDifferent := False;
          for j := 0 to High(aLed[i].InletCode) do
            if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then begin
              IsDifferent := True;
              Break;
            end;
          if IsDifferent then begin
            if ColorLed then begin // m
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
              SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True); // ܦ渹 FEH ~ FEH
            end else begin // 
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
              SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
            end;
            for j := 0 to High(aLed[i].InletCode) do
              if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then begin
                if ckbMsgShowCode.Checked then
                  Memo.Lines.Add(ShowCode(aLed[i].InletCode[j]));
                for k := 1 to 2 do
                  SendCode(aLed[i].tcp1, aLed[i].InletCode[j], True);
              end;
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].InletCode) + 1)));
            for k := 1 to 2 do
              SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].InletCode) + 1), True);
          end;
        end;
      end else begin // sTƻPª@˦h
        IsDifferent := False;
        for j := 0 to High(aLed[i].InletCode) do begin
          if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then
            IsDifferent := True;
            Break;
          end;
        if IsDifferent then begin
          if ColorLed then begin // m
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
            SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True) // ܦ渹 FEH ~ FEH
          end else begin // 
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
            SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
          end;
          for j := 0 to High(aLed[i].InletCode) do
            if aLed[i].InletCode[j] <> aLed[i].InletCode_Old[j] then begin
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(aLed[i].InletCode[j]));
              for k := 1 to 2 do
                SendCode(aLed[i].tcp1, aLed[i].InletCode[j], True);
            end;
          if ckbMsgShowCode.Checked then
             Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].InletCode) + 1)));
          for k := 1 to 2 do
            SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].InletCode) + 1), True);
        end;
      end;

      // oǰeXOª
      SetLength(aLed[i].InletCode_Old, High(aLed[i].InletCode) + 1);
      for j := 0 to High(aLed[i].InletCode) do
        aLed[i].InletCode_Old[j] := aLed[i].InletCode[j];

      //  w/g °O]Ŧr
      // ]쥻b w/g T, YT, hT
      // TUɫ, n_ w/g T
      // Y°O]Ŧr
      // y aLed[i].FixCycCode[j] = aLed[i].FixCycCode_Old[j], ]N|ǰeF
      for j := 0 to High(aLed[i].FixCycCode_Old) do
        aLed[i].FixCycCode_Old[j] := '';

      //aLed[i].NowMsgKind := 1;
    end else if aLed[i].ShowFixCyc then begin // w/g
      Memo.Lines.add('ǰew/gT');
      aLed[i].HadClear := False;
      // Ĥ@ǰew/gT
      if (High(aLed[i].FixCycCode_Old) = -1) then begin
        if ColorLed then begin // m
          if ckbMsgShowCode.Checked then
             Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
          SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True) // ܦ渹 FEH ~ FEH
        end else begin // 
          if ckbMsgShowCode.Checked then
             Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
          SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
        end;
        for j := 0 to High(aLed[i].FixCycCode) do begin
          if ckbMsgShowCode.Checked then
             Memo.Lines.Add(ShowCode(aLed[i].FixCycCode[j]));
          for k := 1 to 2 do
            SendCode(aLed[i].tcp1, aLed[i].FixCycCode[j], True);
        end;;
        if ckbMsgShowCode.Checked then
          Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1)));
        for k := 1 to 2 do
          SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1), True);
      end else if (High(aLed[i].FixCycCode) <> High(aLed[i].FixCycCode_Old)) then begin // s¹w/gƤP
        if High(aLed[i].FixCycCode) > High(aLed[i].FixCycCode_Old) then begin // sw/gƸh
          IsDifferent := False;
          for j := 0 to High(aLed[i].FixCycCode_Old) do
            if aLed[i].InletCode[j] <> aLed[i].FixCycCode_Old[j] then begin
              IsDifferent := True;
              Break;
            end;
          if IsDifferent then begin
            if ColorLed then begin // m
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
              SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True); // ܦ渹 FEH ~ FEH
            end else begin // 
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
              SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
            end;
            for j := 0 to High(aLed[i].FixCycCode_Old) do
              if aLed[i].FixCycCode[j] <> aLed[i].FixCycCode_Old[j] then begin
                if ckbMsgShowCode.Checked then
                  Memo.Lines.Add(ShowCode(aLed[i].FixCycCode[j]));
                for k := 1 to 2 do
                  SendCode(aLed[i].tcp1, aLed[i].FixCycCode[j], True);
              end;
            for j := High(aLed[i].FixCycCode_Old) + 1 to High(aLed[i].FixCycCode) do begin
              if ckbMsgShowCode.Checked then
                 Memo.Lines.Add(ShowCode(aLed[i].FixCycCode[j]));
              for k := 1 to 2 do
                SendCode(aLed[i].tcp1, aLed[i].FixCycCode[j], True);
            end;
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1)));
            for k := 1 to 2 do
              SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1), True);
          end;
        end;
        if High(aLed[i].FixCycCode) < High(aLed[i].FixCycCode_Old) then begin // sw/gƸ
          IsDifferent := False;
          for j := 0 to High(aLed[i].FixCycCode) do
            if aLed[i].FixCycCode[j] <> aLed[i].FixCycCode_Old[j] then begin
              IsDifferent := True;
              Break;
            end;
          if IsDifferent then begin
            if ColorLed then begin // m
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
              SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True); // ܦ渹 FEH ~ FEH
            end else begin // 
              if ckbMsgShowCode.Checked then
                Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
              SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
            end;
            for j := 0 to High(aLed[i].FixCycCode) do
              if aLed[i].FixCycCode[j] <> aLed[i].FixCycCode_Old[j] then begin
                if ckbMsgShowCode.Checked then
                  Memo.Lines.Add(ShowCode(aLed[i].FixCycCode[j]));
                for k := 1 to 2 do
                  SendCode(aLed[i].tcp1, aLed[i].FixCycCode[j], True);
              end;
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1)));
            for k := 1 to 2 do
              SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1), True);
          end;
        end;
      end else begin // s¹w/gT@˦h
        IsDifferent := False;
        for j := 0 to High(aLed[i].FixCycCode) do begin
          if aLed[i].FixCycCode[j] <> aLed[i].FixCycCode_Old[j] then
            IsDifferent := True;
            Break;
          end;
        if IsDifferent then begin
          if ColorLed then begin // m
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
            SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True) // ܦ渹 FEH ~ FEH
          end else begin // 
            if ckbMsgShowCode.Checked then
              Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
            SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
          end;
          for j := 0 to High(aLed[i].FixCycCode) do
            if aLed[i].FixCycCode[j] <> aLed[i].FixCycCode_Old[j] then begin
              if ckbMsgShowCode.Checked then
                 Memo.Lines.Add(ShowCode(aLed[i].FixCycCode[j]));
              for k := 1 to 2 do
                SendCode(aLed[i].tcp1, aLed[i].FixCycCode[j], True);
            end;

          for k := 1 to 2 do
            SendCode(aLed[i].tcp1, GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1), True);
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(GetLineCountCode('A2', High(aLed[i].FixCycCode) + 1)));
        end;
      end;

      SetLength(aLed[i].FixCycCode_Old, High(aLed[i].FixCycCode) + 1);
      for j := 0 to High(aLed[i].FixCycCode) do
        aLed[i].FixCycCode_Old[j] := aLed[i].FixCycCode[j];

      //aLed[i].NowMsgKind := 1;
    end;
    // L, ]Lw/g, ܪťչ( 254 )
    if (not aLed[i].ShowInlet) and (not aLed[i].ShowFixCyc) then begin
      if not aLed[i].HadClear then begin
        Memo.Lines.Add('M');
        aLed[i].HadClear := True;
        if ColorLed then begin // m
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(#2'A2'#184#254#254#203#3));
          SendCode(aLed[i].tcp1, #2'A2'#184#254#254#203#3, True) // ܦ渹 FEH ~ FEH
        end else begin // 
          if ckbMsgShowCode.Checked then
            Memo.Lines.Add(ShowCode(#2'A2'#168#254#254#214#3));
          SendCode(aLed[i].tcp1, #2'A2'#168#254#254#214#3, True);
        end;
      end;
    end;

    // Lucent ƭ
    Memo.Lines.Add('ǰe ACD ƭ');
    qry := dmTable.qryWallboard;
    qry.Close; // Select * From Wallboard Where IP = :IP
    qry.Parameters.ParamValues['IP'] := aLed[i].IP;
    qry.Open;
    for j := 0 to High(aLed[i].IDNOArray) do // s Wallboard ҭnܪ IDNO
      aLed[i].IDNOArray[j] := qry.FieldByName('IDNO' + IntToStr(j+1)).AsInteger;

    TmpIDNOCount := 0;
    for j := 0 to High(aLed[i].IDNOArray) do
      if aLed[i].IDNOArray[j] <> 0 then
        Inc(TmpIDNOCount); // pӤݪOneX()

    //if (aLed[i].NowMsgKind in [0, 1]) then begin
    //  if ColorLed then // m
    //    SendCode(aLed[i].tcp1, #2'A0'#184#254#254#203#3) // ܦ渹 FEH ~ FEH
    //  else // 
    //    SendCode(aLed[i].tcp1, #2'A0'#168#254#254#214#3);
    //end else
      if aLed[i].IDNOCount <> TmpIDNOCount then begin // o@nǪƻPW@P, oe A8H/B8H
        aLed[i].IDNOCount := TmpIDNOCount;
        if ckbACDShowCode.Checked then
          Memo.Lines.Add(ShowCode(GetLineCountCode('A1', TmpIDNOCount)));
        SendCode(aLed[i].tcp1, GetLineCountCode('A1', TmpIDNOCount), False);
      end;

    TmpLineNo := 1;
    for j := 0 to High(aLed[i].IDNOArray) do begin
      if aLed[i].IDNOArray[j] <> 0 then begin
        if aLed[i].IDNOArray[j] > (High(CodeByIDNO) + 1) then Continue;
        // ǰeW, Yǰe A1 
        if ColorLed then
          //            B1H    渹
          TmpCode := 'A1'#177 + Chr(TmpLineNo)
            // r                               \
            + CodeByIDNO[aLed[i].IDNOArray[j] - 1] + 'S'
        else
          TmpCode := 'A1'#161 + Chr(TmpLineNo)
            + CodeByIDNO[aLed[i].IDNOArray[j] - 1] + 'N';
        TmpCode := STX + TmpCode + CheckSum(TmpCode) + ETX;
        if ckbACDShowCode.Checked then
          Memo.Lines.Add(ShowCode(TmpCode));
        SendCode(aLed[i].tcp1, TmpCode, False);

        Inc(TmpLineNo);
      end;
    end;
    //if (aLed[i].NowMsgKind in [0, 1]) then // e 'A0',  A1 P A2 Pɱ, WUPB
    //  SendCode(aLed[i].tcp1, GetLineCountCode('A0', TmpIDNOCount));

    //aLed[i].NowMsgKind := 2;
  end;
end;

// -- ]wUԿ
procedure TfrmMain.SetComboItem;
var sTmp: string;
  qry: TADOQuery;
begin
  sTmp := '';
  qry := dmTable.qrySetCombo;

  qry.Close;
  qry.SQL.Text := 'Select * From SrvGroup';
  qry.Open;
  cmbGrpVDNName.Items.Clear;
  while not qry.Eof do begin
    sTmp := qry.FieldByName('GrpName').AsString + #9
      + qry.FieldByName('GrpSeq').AsString;
    cmbGrpVDNName.Items.Add(sTmp);
    qry.Next;
  end;

  qry.Close;
  qry.SQL.Text := 'Select * From VDN';
  qry.Open;
  while not qry.Eof do begin
    sTmp := qry.FieldByName('VDNName').AsString + #9
      + qry.FieldByName('VDNSeq').AsString;
    cmbGrpVDNName.Items.Add(sTmp);
    qry.Next;
  end;

  qry.Close;
  qry.SQL.Text := 'Select * From ItemType';
  qry.Open;
  cmbItemName.Items.Clear;
  cmbItem.Items.Clear;
  while not qry.Eof do begin
    sTmp := qry.FieldByName('ItemName').AsString + #9
      + qry.FieldByName('ItemID').AsString;
    cmbItemName.Items.Add(sTmp);
    cmbItem.Items.Add(sTmp);
    qry.Next;
  end;

  qry.Close;
  qry.SQL.Text := 'Select * From WallboardLocation';
  qry.Open;
  cmbLocation.Items.Clear;
  while not qry.Eof do begin
    sTmp := qry.FieldByName('Location').AsString + #9
      + qry.FieldByName('IP').AsString;;
    cmbLocation.Items.Add(sTmp);
    qry.Next;
  end;

  qry.Close;
  qry.SQL.Text := 'Select IDNO From DispSeq';
  qry.Open;
  cmbIDNO.Items.Clear;
  cmbIDNO.Items.Add('0');
  while not dmTable.qrySetCombo.Eof do begin
    cmbIDNO.Items.Add(IntToStr(dmTable.qrySetCombo.FieldByName('IDNO').AsInteger));
    dmTable.qrySetCombo.Next;
  end;

  qry.Close;
end;

procedure TfrmMain.btnClearMemoClick(Sender: TObject);
begin
  Memo.Clear;
end;

procedure TfrmMain.ApdWinsockPortWsConnect(Sender: TObject);
begin
  Memo.Lines.Add(FormatDateTime('hh:mm:ss ', Now)
    + TApdWinsockPort(Sender).WsAddress + '('
    + TApdWinsockPort(Sender).WsPort + ')');

  TApdWinsockPort(Sender).PutString(LineFE);
  case TApdWinsockPort(Sender).WaitForMultiString(#6'^'#21, 60, True, True, '^') of
    0: Memo.Lines.Add('Send ' + TApdWinsockPort(Sender).WsAddress + ' empty line, wait ack timeout');
    1: Memo.Lines.Add('Send ' + TApdWinsockPort(Sender).WsAddress + ' empty line, get ack');
    2: Memo.Lines.Add('Send ' + TApdWinsockPort(Sender).WsAddress + ' empty line, get nak');
  end;
end;

procedure TfrmMain.ApdWinsockPortWsDisconnect(Sender: TObject);
begin
  Memo.Lines.Add(FormatDateTime('hh:mm:ss ', Now)
    + TApdWinsockPort(Sender).WsAddress + '('
    + TApdWinsockPort(Sender).WsPort + ')');
end;

procedure TfrmMain.ApdWinsockPortWsError(Sender: TObject;
  ErrCode: Integer);
begin
  Memo.Lines.Add(FormatDateTime('hh:mm:ss ', Now)
    + TApdWinsockPort(Sender).WsAddress + '('
    + TApdWinsockPort(Sender).WsPort
    + ')Socket error checked :'
    + IntToStr(ErrCode) );
end;

{ ǰer:
  02H +  + A1H/B1H + r + CheckSum + 03H
  r: 渹 +  + e\(ߧY) + D1H + r + \
  W毸 A1; U毸 A2;  }
procedure TfrmMain.btnMakeLucentCodeClick(Sender: TObject);
  function AddColorCode(const Source: string; const Color: Integer): AnsiString;
  var i: Integer;
  begin
    Result := '';

    i := 1;
    while i <= Length(Source) do
      if IsDBCSLeadByte(Byte(Source[i])) then begin
        case Color of
          1: Result := Result + #33#33 + Source[i] + Source[i+1]; // ά
          2: Result := Result + #36#36 + Source[i] + Source[i+1]; // κ
          3: Result := Result + #37#37 + Source[i] + Source[i+1]; // ζ
          else
            Result := Result + #33#33 + Source[i] + Source[i+1]; // ά
        end;
        Inc(i, 2);
      end else begin
        case Color of
          1: Result := Result + #1 + Source[i]; // bά
          2: Result := Result + #4 + Source[i]; // bκ
          3: Result := Result + #5 + Source[i]; // bζ
          else
            Result := Result + #1 + Source[i]; // bά
        end;
        Inc(i);
      end;
  end;
var
  i, j, k, iTmpColor, iTmpValue: Integer;

  TmpIDNO, TmpDelay: Integer;
  CodeUp, CodeDown: AnsiString;
  LineUp, LineDown, TmpItem, TmpItemID, TmpValue: string;
begin
  dmTable.tblSrvGroup.DisableControls;
  dmTable.tblSrvGroup.Requery();
  dmTable.tblVDN.DisableControls;
  dmTable.tblVDN.Requery();
  dmTable.tblItemType.Requery();
  dmTable.tblItemType.DisableControls;
  dmTable.tblDispseq.Requery();
  dmTable.tblDispseq.DisableControls;
  dmTable.tblDispColor.Requery();
  dmTable.tblDispColor.DisableControls;
  dmTable.tblWallboard.Requery();
  dmTable.tblWallboard.DisableControls;

  dmTable.tblMakeCodeByIDNO.DisableControls;
  dmTable.tblMakeCodeByIDNO.Requery();
  SetLength(CodeByIDNO, dmTable.tblMakeCodeByIDNO.RecordCount);

  dmTable.qryDispColor := dmTable.qryDispColor;

  for i := 0 to dmTable.tblMakeCodeByIDNO.RecordCount - 1 do begin
    TmpIDNO := dmTable.tblMakeCodeByIDNO.FieldByName('IDNO').AsInteger;
    TmpDelay := dmTable.tblMakeCodeByIDNO.FieldByName('Delay').AsInteger;
    //  + e\('N' ܥߧY) + D1H(᭱ұrWU椧bέ^Ʀr
    if ColorLed then
      CodeByIDNO[i] := Chr(TmpDelay) + 'N' + #193 // C1H
    else
      CodeByIDNO[i] := Chr(TmpDelay) + 'N' + #209; // D1H

    CodeUp := '';
    CodeDown := '';
    if Pos('G', dmTable.tblMakeCodeByIDNO.FieldByName('GrpVDNSeq').AsString) <> 0 then
      LineUp := dmTable.tblMakeCodeByIDNO.FieldByName('GrpName').AsString;
    if Pos('V', dmTable.tblMakeCodeByIDNO.FieldByName('GrpVDNSeq').AsString) <> 0 then
      LineUp := dmTable.tblMakeCodeByIDNO.FieldByName('VDNName').AsString;
    LineDown := '';
    while Length(LineUp) < dmTable.tblMakeCodeByIDNO.FieldByName('GrpVDNSize').AsInteger do
      LineUp := LineUp + ' ';
    LineUp := LineUp + ' '; // PU@ Item Ť@
    while Length(LineDown) < Length(LineUp) do
      LineDown := LineDown + ' ';
    if ColorLed then begin
      for k := 1 to Length(LineDown) do
        CodeDown := CodeDown + #1 + LineDown[k];
    end else
      CodeDown := LineDown;

    for j := 1 to 7 do begin // 7  Item
      TmpItem := dmTable.tblMakeCodeByIDNO.FieldByName('ItemName' + IntToStr(j)).AsString;
      if TmpItem = '' then Break;
      TmpItemID := dmTable.tblMakeCodeByIDNO.FieldByName('ItemID' + IntToStr(j)).AsString;

      dmTable.qryDispColor.Close; // Select * From DispColor Where IDNO = :IDNO And ItemID = :ItemID
      dmTable.qryDispColor.Parameters.ParamValues['IDNO'] := TmpIDNO;
      dmTable.qryDispColor.Parameters.ParamValues['ItemID'] := TmpItemID;
      dmTable.qryDispColor.Open;
      if dmTable.qryDispColor.IsEmpty then
        if ColorLed then
          Memo.Lines.Add(']ws ' + IntToStr(dmTable.tblMakeCodeByIDNO.FieldByName('IDNO').AsInteger)
            + '  ' + TmpItem + ' /C/, Htιw]ȳBz')
        else
          Memo.Lines.Add(']ws ' + IntToStr(dmTable.tblMakeCodeByIDNO.FieldByName('IDNO').AsInteger)
            + '  ' + TmpItem + ' /, Htιw]ȳBz');

      TmpValue := dmTable.tblMakeCodeByIDNO.FieldByName('Value' + IntTostr(j)).AsString;
      iTmpValue := 0;
      if (TmpValue <> ' ') and (TmpValue <> '') then
        iTmpValue := StrToInt(TmpValue);

      iTmpColor := dmTable.qryDispColor.FieldByName('BColor').AsInteger;
      if (TmpValue <> ' ') and (TmpValue <> '') then begin
        if ColorLed then begin
          if iTmpValue > dmTable.qryDispColor.FieldByName('HValue').AsInteger then // OW
            iTmpColor := dmTable.qryDispColor.FieldByName('HColor').AsInteger
          else if iTmpValue < dmTable.qryDispColor.FieldByName('LValue').AsInteger then
            iTmpColor := dmTable.qryDispColor.FieldByName('LColor').AsInteger
        end;
        // TmpItemID ҥN Item  Value ɶ榡
        if (TmpItemID = '2') or (TmpItemID = '3') or (TmpItemID = '5') or (TmpItemID = '7') then
          if iTmpValue >= 60 then
            TmpValue := IntToStr(iTmpValue div 60) + ':' + IntToStr(iTmpValue mod 60)
          else
            TmpValue := ':' + TmpValue;
      end;
      while Length(TmpItem) < Length(TmpValue) do
        TmpItem := ' ' + TmpItem;
      while Length(TmpValue) < Length(TmpItem) do
        TmpValue := ' ' + TmpValue;
      while Length(TmpItem) < dmTable.qryDispColor.FieldByName('ISize').AsInteger do begin
        TmpItem := TmpItem + ' ';
        TmpValue := TmpValue + ' ';
      end;
      TmpItem := TmpItem + ' '; // PU@ Item Ť@bΪť
      TmpValue := TmpValue + ' ';

      LineUp := LineUp + TmpItem;
      LineDown := LineDown + TmpValue;

      if Length(LineUp) = (WallboardLength*2 + 1) then begin
        Delete(TmpItem, Length(TmpItem), 1);
        Delete(TmpValue, Length(TmpValue), 1);
        Delete(LineUp, Length(LineUp), 1);
        Delete(LineDown, Length(LineDown), 1);
      end else if Length(LineUp) > (WallboardLength*2 + 2) then begin
        Memo.Lines.Add('s ' + IntToStr(TmpIDNO) + '  ' + TmpItem
          + 'wWL Wallboard ');
        Delete(LineUp, Length(LineUp) - Length(TmpItem), Length(TmpItem));
        Delete(LineDown, Length(LineDown) - Length(TmpValue), Length(TmpValue));
        Break; // 8פwWL, HU Item Bz
      end;

      if ColorLed then
        case iTmpColor of
          1: CodeDown := CodeDown + AddColorCode(TmpValue, 1); // 
          2: CodeDown := CodeDown + AddColorCode(TmpValue, 2); // 
          3: CodeDown := CodeDown + AddColorCode(TmpValue, 3); // 
          else
            CodeDown := CodeDown + AddColorCode(TmpValue, 1); // 
        end
      else CodeDown := CodeDown + TmpValue;

      if Length(LineUp) >= WallboardLength*2 then Break;
    end; // for j
    while Length(LineUp) < WallboardLength*2 do begin
      LineUp := LineUp + ' ';
      LineDown := LineDown + ' ';
      if ColorLed then
        CodeDown := CodeDown + #1 + ' '
      else
        CodeDown := CodeDown + ' ';
    end;

    if ColorLed then
      case dmTable.tblMakeCodeByIDNO.FieldByName('GrpVDNColor').AsInteger of
        1: CodeUp := CodeUp + AddColorCode(LineUp, 1); // 
        2: CodeUp := CodeUp + AddColorCode(LineUp, 2); // 
        3: CodeUp := CodeUp + AddColorCode(LineUp, 3); // 
      end
    else
      CodeUp := LineUp;

    CodeByIDNO[i] := CodeByIDNO[i] + CodeUp + CodeDown;
    dmTable.tblMakeCodeByIDNO.Next;
  end; // for i

  dmTable.tblSrvGroup.EnableControls;
  dmTable.tblVDN.EnableControls;
  dmTable.tblItemType.EnableControls;
  dmTable.tblDispseq.EnableControls;
  dmTable.tblDispColor.EnableControls;
  dmTable.tblWallboard.EnableControls;
  dmTable.tblMakeCodeByIDNO.EnableControls;
end;

procedure TfrmMain.btnMakeCommonCodeClick(Sender: TObject);
var i, j, TmpRecCount: Integer;
begin
  dmTable.UpdateDBFlag; // s Inlet/Fixtime/Cycle  Table  Status 

  for i := 0 to High(aLed) do begin
    aLed[i].ShowInlet := False;
    dmTable.qryGetInlet.Close;
    dmTable.qryGetInlet.Parameters.ParamValues['IP'] := aLed[i].IP;
    dmTable.qryGetInlet.Open;
    if not dmTable.qryGetInlet.IsEmpty then begin // 
      aLed[i].ShowInlet := True;
      SetLength(aLed[i].InletCode, dmTable.qryGetInlet.RecordCount);

      j := 0;
      while not dmTable.qryGetInlet.Eof do begin
        if j = 255 then Break; // 渹̦h 254 
        if ColorLed then
          aLed[i].InletCode[j] := 'A2'#177 // ; ҦX(B1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetInlet.FieldByName('Code').AsString
        else
          aLed[i].InletCode[j] := 'A2'#161 // ; ҦX(A1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetInlet.FieldByName('Code').AsString;
        aLed[i].InletCode[j] := aLed[i].InletCode[j] + CheckSum(aLed[i].InletCode[j]);
        aLed[i].InletCode[j] := STX + aLed[i].InletCode[j] + ETX;
        Inc(j);
        dmTable.qryGetInlet.Next;
      end;
      Continue;
    end else begin // L, ˬd w/g
      for j := 0 to High(aLed[i].InletCode_Old) do
        aLed[i].InletCode_Old[j] := '';

      aLed[i].ShowFixCyc := False;
      TmpRecCount := 0;
      dmTable.qryGetFixtime.Close;
      dmTable.qryGetFixtime.Parameters.ParamValues['IP'] := aLed[i].IP;
      dmTable.qryGetFixtime.Open;
      dmTable.qryGetCycle.Close;
      dmTable.qryGetCycle.Parameters.ParamValues['IP'] := aLed[i].IP;
      dmTable.qryGetCycle.Open;
      if not dmTable.qryGetFixtime.IsEmpty then begin
        TmpRecCount := dmTable.qryGetFixtime.RecordCount;
        aLed[i].ShowFixCyc := True;
      end;
      if not dmTable.qryGetCycle.IsEmpty then begin
        TmpRecCount := TmpRecCount + dmTable.qryGetCycle.RecordCount;
        aLed[i].ShowFixCyc := True;
      end;
      SetLength(aLed[i].FixCycCode, TmpRecCount);

      j := 0;
      while not dmTable.qryGetFixtime.Eof do begin
        if j = 255 then Break;
        if ColorLed then
          aLed[i].FixCycCode[j] := 'A2'#177 // ; ҦX(B1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetFixtime.FieldByName('Code').AsString
        else
          aLed[i].FixCycCode[j] := 'A2'#161 // ; ҦX(A1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetFixtime.FieldByName('Code').AsString;
        aLed[i].FixCycCode[j] := aLed[i].FixCycCode[j] + CheckSum(aLed[i].FixCycCode[j]);
        aLed[i].FixCycCode[j] := STX + aLed[i].FixCycCode[j] + ETX;
        Inc(j);
        dmTable.qryGetFixtime.Next;
      end;
      while not dmTable.qryGetCycle.Eof do begin
        if j = 255 then Break;
        if ColorLed then
          aLed[i].FixCycCode[j] := 'A2'#177 // ; ҦX(B1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetCycle.FieldByName('Code').AsString
        else
          aLed[i].FixCycCode[j] := 'A2'#161 // ; ҦX(A1H: ǰer)
            + Chr(j+1) // 渹
            + dmTable.qryGetCycle.FieldByName('Code').AsString;
        aLed[i].FixCycCode[j] := aLed[i].FixCycCode[j] + CheckSum(aLed[i].FixCycCode[j]);
        aLed[i].FixCycCode[j] := STX + aLed[i].FixCycCode[j] + ETX;
        Inc(j);
        dmTable.qryGetCycle.Next;
      end;

      if dmTable.qryGetFixtime.IsEmpty and dmTable.qryGetCycle.IsEmpty then
        for j := 0 to High(aLed[i].FixCycCode_Old) do
          aLed[i].FixCycCode_Old[j] := '';
    end; // if qryGetInlet.IsEmpty
  end; // for i
end;

procedure TfrmMain.tmSendTimer(Sender: TObject);
var hWnd: Integer;
begin
  if btnTimerState.Caption = 'Timer Off' then Exit;
  if PrevTimer then Exit;
  PrevTimer := True;
  try
    Memo.Lines.Add('');
    Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + ' Compile Lucent Code');
    btnMakeLucentCode.Click;
    Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + ' Compile Common Code');
    btnMakeCommonCode.Click;
    Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + ' Send Code');
    btnSend.Click;
    Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + ' Finished');
  finally
    hWnd := FindWindow(PChar('TApplication'), PChar('GetSkill {'));
    if hWnd = 0 then
      ShellExecute(0, PChar('open'),
        PChar('C:\Program Files\Borland\Delphi5\Wallboard\GetSkill\GetSkill.Exe'),
        nil, nil, SW_SHOW);

    hWnd := FindWindow(PChar('TApplication'), PChar('GetVDN {'));
    if hWnd = 0 then
      ShellExecute(0, PChar('open'),
        PChar('C:\Program Files\Borland\Delphi5\Wallboard\GetVDN\GetVDN.Exe'),
        nil, nil, SW_SHOW);

    PrevTimer := False;
  end;
end;

procedure TfrmMain.btnTimerStateClick(Sender: TObject);
begin
  if btnTimerState.Caption = 'Timer On' then
    btntimerState.Caption := 'Timer Off'
  else
    btntimerState.Caption := 'Timer On'
end;

procedure TfrmMain.seSendIntervalChange(Sender: TObject);
begin
  if seSendInterval.Text <> '' then begin
    tmSend.Enabled := False;
    tmSend.Interval := seSendInterval.Value * 1000;
    tmSend.Enabled := True;
  end;
end;

procedure TfrmMain.ApplicationEvents1Exception(Sender: TObject;
  E: Exception);
var f: TextFile;
  fName: string;
  fHnd: Integer;
begin
  Memo.Lines.Add(FormatDateTime('hh:nn:ss ', Now) + E.Message);

  fName := 'C:\WallDb\Log\WallCtrl\' + FormatDateTime('MMDD', Now) + '.txt';
  if not FileExists(fName) then begin
    fHnd := FileCreate(fName);
    if fHnd <> -1 then
      FileClose(fHnd);
  end;

  AssignFile(f, fName);
  try
    Append(f);
    WriteLn(f, FormatDateTime('hh:nn:ss ', Now) + E.Message);
  finally
    CloseFile(f);
  end;
  Application.Terminate;
end;

end.
